#include        <stdio.h>
#include        <sys/time.h>
#include        <sys/resource.h>

struct rusage   start_rusage;
struct rusage   stop_rusage;

void startwatch( who )
        int who;
{

        if( getrusage( who, &start_rusage ) != 0 ) {
          fprintf(stderr,"\ngetrusage error");
          exit(1);
          }
}

double stopwatch( who )
        int     who;
{
double                          time, stime, utime;

if( getrusage( who, &stop_rusage ) != 0 ) {
   fprintf(stderr,"\ngetrusage error");
   exit(1);
   }


time = ((double)stop_rusage.ru_utime.tv_sec - 
        (double)start_rusage.ru_utime.tv_sec) + 
       ((double)stop_rusage.ru_utime.tv_usec -
        (double)start_rusage.ru_utime.tv_usec) / 1000000.0; 
printf( "user time used %f   ", time );
utime = time;

time = ((double)stop_rusage.ru_stime.tv_sec - 
        (double)start_rusage.ru_stime.tv_sec) + 
       ((double)stop_rusage.ru_stime.tv_usec -
        (double)start_rusage.ru_stime.tv_usec) / 1000000.0; 
printf( "system time used %f\n", time );
stime = time;

	return stime + utime;
}
